# MapGISTerrainProvider

MapGISTerrainProvider MapGIS地形provider

#### new Cesium.MapGISTerrainProvider(options)
MapGIS/MapGISTerrainProvider.js 95

Name | Type | Description
--- | --- | ---

`options`

Object

Name | Type | Default | Description
--- | --- | --- | ---
`showSkirt` | Boolean | `true` | optional 是否显示裙边
`range` | Object |  | optional 数据范围
`terrainFormat` | Boolean | `true` | optional 如果使用地形缓存值为false，否则为true
`proxy` | Proxy |  | optional 使用代理
`requestVertexNormals` | Boolean | `true` | optional 是否使用地形法向
`maxLevel` | Number | `20` | optional 最大级别

### Members

#### credit : Credit
MapGIS/MapGISTerrainProvider.js 1204

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### errorEvent : Event
MapGIS/MapGISTerrainProvider.js 1181

Gets an event that is raised when the terrain provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### hasVertexNormals : Boolean
MapGIS/MapGISTerrainProvider.js 1285

Gets a value indicating whether or not the requested tiles include vertex normals. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### hasWaterMask : Boolean
MapGIS/MapGISTerrainProvider.js 1266

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves. This function should not be called before `MapGISTerrainProvider#ready` returns true.

#### ready : Boolean
MapGIS/MapGISTerrainProvider.js 1239

Gets a value indicating whether or not the provider is ready for use.

#### readonlyreadyPromise : Promise.<Boolean>
MapGIS/MapGISTerrainProvider.js 1251

Gets a promise that resolves to true when the provider is ready for use.

#### requestVertexNormals : Boolean
MapGIS/MapGISTerrainProvider.js 1325

Boolean flag that indicates if the client should request vertex normals from the server. Vertex normals data is appended to the standard tile mesh data only if the client requests the vertex normals and if the server provides vertex normals.

#### requestWaterMask : Boolean
MapGIS/MapGISTerrainProvider.js 1338

Boolean flag that indicates if the client should request a watermask from the server. Watermask data is appended to the standard tile mesh data only if the client requests the watermask and if the server provides a watermask.

#### showSkirt
MapGIS/MapGISTerrainProvider.js 1190

是否显示裙边（只有MapGIS的地形可以设置）

#### tilingScheme : GeographicTilingScheme
MapGIS/MapGISTerrainProvider.js 1222

Gets the tiling scheme used by this provider. This function should not be called before `MapGISTerrainProvider#ready` returns true.

### Methods

#### getLevelMaximumGeometricError(level) → Number
MapGIS/MapGISTerrainProvider.js 1383

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | Number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → Boolean
MapGIS/MapGISTerrainProvider.js 1395

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported or availability is unknown, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined|Promise
MapGIS/MapGISTerrainProvider.js 1433

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if nothing need to be loaded or a Promise that resolves when all required tiles are loaded

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
MapGIS/MapGISTerrainProvider.js 985

Requests the geometry for a given tile. This function should not be called before `CesiumTerrainProvider#ready` returns true. The result must include terrain data and may optionally include a water mask and an indication of which child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

##### Throws:

- DeveloperError : This function must not be called before `CesiumTerrainProvider#ready` returns true.